Bug 150162 - msync(..., ..., MS_SYNC) returning before data written to disk
msync(..., ..., MS_SYNC) returning before data written to disk
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 2.1
Classification: Red Hat
Component: kernel (Show other bugs)
2.1
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Jim Paradis
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-03-02 23:10 EST by Jim Paradis
Modified: 2013-08-05 21:12 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-04-28 11:05:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jim Paradis 2005-03-02 23:10:52 EST
This bug is to track the RHEL2.1 variant of Bug 147969.

From that bug report:

Description of problem:
Calling msync(p, size, MS_SYNC) on a memory mapped file is not waiting for the
data to be flushed to disk [eg a 128Mb chunk of data is claiming to be flushed
in 1-2ms : cf 2.4.21-15 / 2.6.8-1.521 where the same test code takes 2-3s to do
this]

This means that there is no way for code to know that the data it has just
written to a memory mapped file has actually made it to disk.

Version-Release number of selected component (if applicable):
kernel-2.4.21-20.EL and kernel-2.4.21-27.0.2.EL

How reproducible:
Always

Steps to Reproduce:
1.mmap a (large-ish) file
2.write some data into the memory region
3.call msync with the MS_SYNC option
4.reboot the PC by hitting the power switch once msync has completed... [or time
how long it takes to sync the data]
5.look at the contents of the file
    

Actual Results:  Data missing from file on disk (was present in file (ie disk
buffers) prior to hitting power)

Expected Results:  msync should wait for the data to be written to disk when the
MS_SYNC flag is used.
Comment 1 Jim Paradis 2005-03-02 23:11:36 EST
A fix for this problem has just been committed to the RHEL2.1 U7
patch pool this evening (in kernel version 2.4.9-61).
Comment 2 John Flanagan 2005-04-28 11:05:55 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-283.html

Note You need to log in before you can comment on or make changes to this bug.